package com.sckj.project.domain.car;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonInclude;
import lombok.Data;

import java.math.BigDecimal;

@Data
@TableName("large_plat_public_car")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class LargeCar {
    private Long id;

    /**
     * 所属单位
     */
    private String appEncode;

    @TableField(exist = false)
    private String appOrg;

    private String orgName;

    /**
     * 公务车实有总数
     */
    private Long totalCarNum;

    /**
     * 商务车数量
     */
    private Long carNumOne;

    /**
     * 越野车数量
     */
    private Long carNumTwo;

    /**
     * 小轿车数量
     */
    private Long carNumThree;

    /**
     * 小型客车数量
     */
    private Long carNumFour;

    /**
     * 大型客车数量
     */
    private Long carNumFive;

    /**
     * 企业用车数量
     */
    private Long enterpriseCarNum;

    /**
     * 企业负责人用车数量
     */
    private Long headCarNum;

    /**
     * 燃油车数量
     */
    private Long oilCarNum;

    /**
     * 新能源车数量
     */
    private Long newPowerCarNum;



    /**
     * 公务车编制数
     */
    private Long establishmentsCarNum;

    /**
     * 公务车年度增加数
     */
    private Long yearAddNum;

    /**
     * 公务车年度减少数
     */
    private Long yearReduceNum;

    /**
     * 公务车终端数
     */
    private Long terminalTotal;

    /**
     * 公务车终端安装数
     */
    private Long terminalInstall;

    /**
     * 公务车终端在线数
     */
    private Long terminalOnline;

    /**
     * 处置未归档数量
     */
    private Long notArchivedNum;

    /**
     * 未带工单数
     */
    private Long noPidNum;

    /**
     * 超速预警数
     */
    private Long overSpeedNum;

    /**
     * 节假日预警数
     */
    private Long holidayNum;

    /**
     * 派车单总数
     */
    private Long pcdNum;

    /**
     * 均车派车单数
     */
    private Long avgPcdNum;

    /**
     * 公务车行驶总里程
     */
    private BigDecimal mileCount;

    /**
     * 均车里程
     */
    private BigDecimal avgMile;
}
