package com.sckj.project.service.impl.car;

import cn.hutool.json.JSONArray;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.sckj.project.domain.car.LargeCar;
import com.sckj.project.mapper.car.LargeCarMapper;
import com.sckj.project.service.car.ILargeCarService;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 公务用车Service业务层处理
 *
 * @author change
 * @date 2025-03-05
 */
@Service
public class LargeCarServiceImpl extends ServiceImpl<LargeCarMapper, LargeCar> implements ILargeCarService {

    public void saveOrUpdate(JSONArray array){
        try {
            if (array == null){
                return;
            }
            List<LargeCar> list = array.toList(LargeCar.class);
            if (list.size() < 1){
                return;
            }
            for (LargeCar it : list){
                LambdaQueryWrapper<LargeCar> queryWrapper = new LambdaQueryWrapper<>();
                queryWrapper.eq(LargeCar::getAppEncode, it.getAppEncode());
                if (count(queryWrapper) > 0){
                    LambdaUpdateWrapper<LargeCar> updateWrapper = new LambdaUpdateWrapper<>();
                    updateWrapper.eq(LargeCar::getAppEncode, it.getAppEncode());
                    update(it, updateWrapper);
                }
                else {
                    save(it);
                }
            }
        } catch (Exception e) {
        }
    }
}
