package com.sckj.project.service.impl.logistics;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.sckj.project.domain.logistics.LargeBuildingAssetDirs;
import com.sckj.project.mapper.logistics.LargePlatLogisticsBuildingAssetMapper;
import com.sckj.project.service.logistics.ILargePlatLogisticsBuildingAssetService;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 楼宇设备Service业务层处理
 *
 * @author change
 * @date 2025-03-05
 */
@Service
public class LargePlatLogisticsBuildingAssetServiceImpl extends ServiceImpl<LargePlatLogisticsBuildingAssetMapper, LargeBuildingAssetDirs> implements ILargePlatLogisticsBuildingAssetService {

    public void saveOrUpdate(List<LargeBuildingAssetDirs> list){
        try {
            if (list.size() < 1){
                return;
            }
            for (LargeBuildingAssetDirs it : list){
                LambdaQueryWrapper<LargeBuildingAssetDirs> queryWrapper = new LambdaQueryWrapper<>();
                queryWrapper.eq(LargeBuildingAssetDirs::getAppCode, it.getAppCode());
                if (count(queryWrapper) > 0){
                    LambdaUpdateWrapper<LargeBuildingAssetDirs> updateWrapper = new LambdaUpdateWrapper<>();
                    updateWrapper.eq(LargeBuildingAssetDirs::getAppCode, it.getAppCode());
                    update(it, updateWrapper);
                }
                else {
                    save(it);
                }
            }
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }
}
