package com.sckj.project.service.impl.logistics;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.sckj.project.domain.logistics.LargeServiceAssetDirs;
import com.sckj.project.mapper.logistics.LargePlatLogisticsServiceAssetMapper;
import com.sckj.project.service.logistics.ILargePlatLogisticsServiceAssetService;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 楼宇设备Service业务层处理
 *
 * @author change
 * @date 2025-03-05
 */
@Service
public class LargePlatLogisticsServiceAssetServiceImpl extends ServiceImpl<LargePlatLogisticsServiceAssetMapper, LargeServiceAssetDirs> implements ILargePlatLogisticsServiceAssetService {

    public void saveOrUpdate(List<LargeServiceAssetDirs> list){
        try {
            if (list.size() < 1){
                return;
            }
            for (LargeServiceAssetDirs it : list){
                LambdaQueryWrapper<LargeServiceAssetDirs> queryWrapper = new LambdaQueryWrapper<>();
                queryWrapper.eq(LargeServiceAssetDirs::getAppCode, it.getAppCode());
                if (count(queryWrapper) > 0){
                    LambdaUpdateWrapper<LargeServiceAssetDirs> updateWrapper = new LambdaUpdateWrapper<>();
                    updateWrapper.eq(LargeServiceAssetDirs::getAppCode, it.getAppCode());
                    update(it, updateWrapper);
                }
                else {
                    save(it);
                }
            }
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }
}
