package com.sckj.project.service.impl.logistics;


import cn.hutool.json.JSONArray;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.sckj.project.domain.logistics.LargeLogistics;
import com.sckj.project.mapper.logistics.LargePlatLogisticsMapper;
import com.sckj.project.service.logistics.ILargePlatLogisticsService;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 后勤运行监控中心Service业务层处理
 *
 * @author change
 * @date 2025-03-05
 */
@Service
public class LargePlatLogisticsServiceImpl extends ServiceImpl<LargePlatLogisticsMapper, LargeLogistics> implements ILargePlatLogisticsService {

    public void saveOrUpdate(JSONArray array){
        try {
            if (array == null){
                return;
            }
            List<LargeLogistics> list = array.toList(LargeLogistics.class);
            if (list.size() < 1){
                return;
            }
            for (LargeLogistics it : list){
                LambdaQueryWrapper<LargeLogistics> queryWrapper = new LambdaQueryWrapper<>();
                queryWrapper.eq(LargeLogistics::getAppCode, it.getAppCode());
                if (count(queryWrapper) > 0){
                    LambdaUpdateWrapper<LargeLogistics> updateWrapper = new LambdaUpdateWrapper<>();
                    updateWrapper.eq(LargeLogistics::getAppCode, it.getAppCode());
                    update(it, updateWrapper);
                }
                else {
                    save(it);
                }
            }
        } catch (Exception e) {
        }
    }
}
