package com.sckj.project.service.impl.service;

import cn.hutool.json.JSONArray;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;

import com.sckj.project.domain.service.PlatAccess;
import com.sckj.project.mapper.service.LargePlatAccessMapper;
import com.sckj.project.service.service.ILargePlatAccessService;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 便捷出入Service业务层处理
 *
 * @author change
 * @date 2025-03-04
 */
@Service
public class LargePlatAccessServiceImpl extends ServiceImpl<LargePlatAccessMapper, PlatAccess> implements ILargePlatAccessService {
    public void saveOrUpdate(JSONArray array){
        try {
            if (array == null){
                return;
            }
            List<PlatAccess> list = array.toList(PlatAccess.class);
            if (list.size() < 1){
                return;
            }
            for (PlatAccess it : list){
                LambdaQueryWrapper<PlatAccess> queryWrapper = new LambdaQueryWrapper<>();
                queryWrapper.eq(PlatAccess::getAppOrg, it.getAppOrg());
                if (count(queryWrapper) > 0){
                    LambdaUpdateWrapper<PlatAccess> updateWrapper = new LambdaUpdateWrapper<>();
                    updateWrapper.eq(PlatAccess::getAppOrg, it.getAppOrg());
                    update(it, updateWrapper);
                }
                else {
                    save(it);
                }
            }
        } catch (Exception e) {
        }
    }

}
