package com.sckj.project.service.impl.service;


import cn.hutool.json.JSONArray;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.sckj.project.domain.service.PlatBasicsCompany;
import com.sckj.project.domain.service.PlatBasicsCompany;
import com.sckj.project.domain.service.PlatBasicsCompany;
import com.sckj.project.mapper.service.LargePlatBasicsCompanyMapper;
import com.sckj.project.service.service.ILargePlatBasicsCompanyService;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 公司活跃人数Service业务层处理
 *
 * @author change
 * @date 2025-03-05
 */
@Service
public class LargePlatBasicsCompanyServiceImpl extends ServiceImpl<LargePlatBasicsCompanyMapper, PlatBasicsCompany> implements ILargePlatBasicsCompanyService {

    public void saveOrUpdate(JSONArray array){
        try {
            if (array == null){
                return;
            }
            List<PlatBasicsCompany> list = array.toList(PlatBasicsCompany.class);
            if (list.size() < 1){
                return;
            }
            for (PlatBasicsCompany it : list){
                LambdaQueryWrapper<PlatBasicsCompany> queryWrapper = new LambdaQueryWrapper<>();
                queryWrapper.eq(PlatBasicsCompany::getAppOrg, it.getAppOrg());
                if (count(queryWrapper) > 0){
                    LambdaUpdateWrapper<PlatBasicsCompany> updateWrapper = new LambdaUpdateWrapper<>();
                    updateWrapper.eq(PlatBasicsCompany::getAppOrg, it.getAppOrg());
                    update(it, updateWrapper);
                }
                else {
                    save(it);
                }
            }
        } catch (Exception e) {
        }
    }
}
