package com.sckj.project.service.impl.service;


import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.sckj.project.domain.service.PlatEmployeeHealthIllness;
import com.sckj.project.domain.service.PlatEmployeeHealthIllness;
import com.sckj.project.mapper.service.LargePlatEmployeeHealthIllnessMapper;
import com.sckj.project.service.service.ILargePlatEmployeeHealthIllnessService;
import org.springframework.stereotype.Service;


import java.util.List;

/**
 * 多发疾病排行Service业务层处理
 *
 * @author change
 * @date 2025-03-05
 */
@Service
public class LargePlatEmployeeHealthIllnessServiceImpl extends ServiceImpl<LargePlatEmployeeHealthIllnessMapper, PlatEmployeeHealthIllness> implements ILargePlatEmployeeHealthIllnessService {

    public void saveOrUpdate(List<PlatEmployeeHealthIllness> list){
        try {
            if (list.size() < 1){
                return;
            }
            for (PlatEmployeeHealthIllness it : list){
                LambdaQueryWrapper<PlatEmployeeHealthIllness> queryWrapper = new LambdaQueryWrapper<>();
                queryWrapper.eq(PlatEmployeeHealthIllness::getAppOrg, it.getAppOrg());
                if (count(queryWrapper) > 0){
                    LambdaUpdateWrapper<PlatEmployeeHealthIllness> updateWrapper = new LambdaUpdateWrapper<>();
                    updateWrapper.eq(PlatEmployeeHealthIllness::getAppOrg, it.getAppOrg());
                    update(it, updateWrapper);
                }
                else {
                    save(it);
                }
            }
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }
}
