package com.sckj.project.service.impl.service;


import cn.hutool.json.JSONArray;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.sckj.project.domain.service.PlatEmployeeHealth;
import com.sckj.project.domain.service.PlatEmployeeHealth;
import com.sckj.project.mapper.service.LargePlatEmployeeHealthMapper;
import com.sckj.project.service.service.ILargePlatEmployeeHealthService;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 员工健康Service业务层处理
 *
 * @author change
 * @date 2025-03-05
 */
@Service
public class LargePlatEmployeeHealthServiceImpl extends ServiceImpl<LargePlatEmployeeHealthMapper,  PlatEmployeeHealth> implements ILargePlatEmployeeHealthService {
    public void saveOrUpdate(JSONArray array){
        try {
            if (array == null){
                return;
            }
            List<PlatEmployeeHealth> list = array.toList(PlatEmployeeHealth.class);
            if (list.size() < 1){
                return;
            }
            for (PlatEmployeeHealth it : list){
                LambdaQueryWrapper<PlatEmployeeHealth> queryWrapper = new LambdaQueryWrapper<>();
                queryWrapper.eq(PlatEmployeeHealth::getAppOrg, it.getAppOrg());
                if (count(queryWrapper) > 0){
                    LambdaUpdateWrapper<PlatEmployeeHealth> updateWrapper = new LambdaUpdateWrapper<>();
                    updateWrapper.eq(PlatEmployeeHealth::getAppOrg, it.getAppOrg());
                    update(it, updateWrapper);
                }
                else {
                    save(it);
                }
            }
        } catch (Exception e) {
        }
    }
}
