package com.sckj.project.service.impl.service;

import cn.hutool.json.JSONArray;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.sckj.project.domain.service.PlatGreenFoods;
import com.sckj.project.domain.service.PlatGreenFoods;
import com.sckj.project.mapper.service.LargePlatGreenFoodsMapper;
import com.sckj.project.service.service.ILargePlatGreenFoodsService;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 菜谱数据Service业务层处理
 *
 * @author change
 * @date 2025-03-05
 */
@Service
public class LargePlatGreenFoodsServiceImpl extends ServiceImpl<LargePlatGreenFoodsMapper, PlatGreenFoods> implements ILargePlatGreenFoodsService {

    public void saveOrUpdate(JSONArray array){
        try {
            if (array == null){
                return;
            }
            List<PlatGreenFoods> list = array.toList(PlatGreenFoods.class);
            if (list.size() < 1){
                return;
            }
            for (PlatGreenFoods it : list){
                LambdaQueryWrapper<PlatGreenFoods> queryWrapper = new LambdaQueryWrapper<>();
                queryWrapper.eq(PlatGreenFoods::getAppOrg, it.getAppOrg());
                if (count(queryWrapper) > 0){
                    LambdaUpdateWrapper<PlatGreenFoods> updateWrapper = new LambdaUpdateWrapper<>();
                    updateWrapper.eq(PlatGreenFoods::getAppOrg, it.getAppOrg());
                    update(it, updateWrapper);
                }
                else {
                    save(it);
                }
            }
        } catch (Exception e) {
        }
    }
}
