package com.sckj.project.service.impl.service;

import cn.hutool.json.JSONArray;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.sckj.project.domain.service.PlatGreenSmartSafety;
import com.sckj.project.domain.service.PlatGreenSmartSafety;
import com.sckj.project.mapper.service.LargePlatGreenSmartSafetyMapper;
import com.sckj.project.service.service.ILargePlatGreenSmartSafetyService;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 食堂安全管理Service业务层处理
 *
 * @author change
 * @date 2025-03-05
 */
@Service
public class LargePlatGreenSmartSafetyServiceImpl extends ServiceImpl<LargePlatGreenSmartSafetyMapper, PlatGreenSmartSafety> implements ILargePlatGreenSmartSafetyService {

    public void saveOrUpdate(JSONArray array){
        try {
            if (array == null){
                return;
            }
            List<PlatGreenSmartSafety> list = array.toList(PlatGreenSmartSafety.class);
            if (list.size() < 1){
                return;
            }
            for (PlatGreenSmartSafety it : list){
                LambdaQueryWrapper<PlatGreenSmartSafety> queryWrapper = new LambdaQueryWrapper<>();
                queryWrapper.eq(PlatGreenSmartSafety::getAppOrg, it.getAppOrg());
                if (count(queryWrapper) > 0){
                    LambdaUpdateWrapper<PlatGreenSmartSafety> updateWrapper = new LambdaUpdateWrapper<>();
                    updateWrapper.eq(PlatGreenSmartSafety::getAppOrg, it.getAppOrg());
                    update(it, updateWrapper);
                }
                else {
                    save(it);
                }
            }
        } catch (Exception e) {
        }
    }
}
