package com.sckj.project.service.impl.service;

import cn.hutool.json.JSONArray;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.sckj.project.domain.service.PlatGreenSmart;
import com.sckj.project.domain.service.PlatGreenSmart;
import com.sckj.project.mapper.service.LargePlatGreenSmartMapper;
import com.sckj.project.service.service.ILargePlatGreenSmartService;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 绿智食堂Service业务层处理
 *
 * @author change
 * @date 2025-03-05
 */
@Service
public class LargePlatGreenSmartServiceImpl extends ServiceImpl<LargePlatGreenSmartMapper, PlatGreenSmart> implements ILargePlatGreenSmartService {

    public void saveOrUpdate(JSONArray array){
        try {
            if (array == null){
                return;
            }
            List<PlatGreenSmart> list = array.toList(PlatGreenSmart.class);
            if (list.size() < 1){
                return;
            }
            for (PlatGreenSmart it : list){
                LambdaQueryWrapper<PlatGreenSmart> queryWrapper = new LambdaQueryWrapper<>();
                queryWrapper.eq(PlatGreenSmart::getAppOrg, it.getAppOrg());
                if (count(queryWrapper) > 0){
                    LambdaUpdateWrapper<PlatGreenSmart> updateWrapper = new LambdaUpdateWrapper<>();
                    updateWrapper.eq(PlatGreenSmart::getAppOrg, it.getAppOrg());
                    update(it, updateWrapper);
                }
                else {
                    save(it);
                }
            }
        } catch (Exception e) {
        }
    }
}
