package com.sckj.project.service.impl.service;

import cn.hutool.json.JSONArray;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.sckj.project.domain.service.PlatPostStation;
import com.sckj.project.domain.service.PlatPostStation;
import com.sckj.project.mapper.service.LargePlatPostStationMapper;
import com.sckj.project.service.service.ILargePlatPostStationService;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 物业服务Service业务层处理
 *
 * @author change
 * @date 2025-03-05
 */
@Service
public class LargePlatPostStationServiceImpl extends ServiceImpl<LargePlatPostStationMapper, PlatPostStation> implements ILargePlatPostStationService {

    public void saveOrUpdate(JSONArray array){
        try {
            if (array == null){
                return;
            }
            List<PlatPostStation> list = array.toList(PlatPostStation.class);
            if (list.size() < 1){
                return;
            }
            for (PlatPostStation it : list){
                LambdaQueryWrapper<PlatPostStation> queryWrapper = new LambdaQueryWrapper<>();
                queryWrapper.eq(PlatPostStation::getAppOrg, it.getAppOrg());
                if (count(queryWrapper) > 0){
                    LambdaUpdateWrapper<PlatPostStation> updateWrapper = new LambdaUpdateWrapper<>();
                    updateWrapper.eq(PlatPostStation::getAppOrg, it.getAppOrg());
                    update(it, updateWrapper);
                }
                else {
                    save(it);
                }
            }
        } catch (Exception e) {
        }
    }
}
