package com.sckj.project.service.impl.service;

import cn.hutool.json.JSONArray;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.sckj.project.domain.service.PlatProperty;
import com.sckj.project.domain.service.PlatProperty;
import com.sckj.project.mapper.service.LargePlatPropertyMapper;
import com.sckj.project.service.service.ILargePlatPropertyService;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 共享驿站Service业务层处理
 *
 * @author change
 * @date 2025-03-05
 */
@Service
public class LargePlatPropertyServiceImpl extends ServiceImpl<LargePlatPropertyMapper, PlatProperty> implements ILargePlatPropertyService {

    public void saveOrUpdate(JSONArray array){
        try {
            if (array == null){
                return;
            }
            List<PlatProperty> list = array.toList(PlatProperty.class);
            if (list.size() < 1){
                return;
            }
            for (PlatProperty it : list){
                LambdaQueryWrapper<PlatProperty> queryWrapper = new LambdaQueryWrapper<>();
                queryWrapper.eq(PlatProperty::getAppOrg, it.getAppOrg());
                if (count(queryWrapper) > 0){
                    LambdaUpdateWrapper<PlatProperty> updateWrapper = new LambdaUpdateWrapper<>();
                    updateWrapper.eq(PlatProperty::getAppOrg, it.getAppOrg());
                    update(it, updateWrapper);
                }
                else {
                    save(it);
                }
            }
        } catch (Exception e) {
        }
    }
}
