package com.sckj.project.service.impl.service;

import cn.hutool.json.JSONArray;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.sckj.project.domain.service.PlatPropertyTools;
import com.sckj.project.domain.service.PlatPropertyTools;
import com.sckj.project.mapper.service.LargePlatPropertyToolsMapper;
import com.sckj.project.service.service.ILargePlatPropertyToolsService;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 工具列Service业务层处理
 *
 * @author change
 * @date 2025-03-05
 */
@Service
public class LargePlatPropertyToolsServiceImpl extends ServiceImpl<LargePlatPropertyToolsMapper, PlatPropertyTools> implements ILargePlatPropertyToolsService {

    public void saveOrUpdate(JSONArray array){
        try {
            if (array == null){
                return;
            }
            List<PlatPropertyTools> list = array.toList(PlatPropertyTools.class);
            if (list.size() < 1){
                return;
            }
            for (PlatPropertyTools it : list){
                LambdaQueryWrapper<PlatPropertyTools> queryWrapper = new LambdaQueryWrapper<>();
                queryWrapper.eq(PlatPropertyTools::getAppOrg, it.getAppOrg());
                if (count(queryWrapper) > 0){
                    LambdaUpdateWrapper<PlatPropertyTools> updateWrapper = new LambdaUpdateWrapper<>();
                    updateWrapper.eq(PlatPropertyTools::getAppOrg, it.getAppOrg());
                    update(it, updateWrapper);
                }
                else {
                    save(it);
                }
            }
        } catch (Exception e) {
        }
    }
}
