package com.sckj.project.task;

import cn.hutool.json.JSONArray;
import cn.hutool.json.JSONUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.sckj.project.config.ApiUrlConfig;
import com.sckj.project.domain.logistics.*;
import com.sckj.project.domain.service.PlatBasicsSystem;
import com.sckj.project.service.logistics.*;
import com.sckj.project.util.AESUtil;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpMethod;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestClientException;
import org.springframework.web.client.RestTemplate;

import java.util.List;

@Service
public class LogisticsTaskService {

    @Autowired
    private ILargePlatHousingLandService largePlatHousingLandService;

    @Autowired
    private ILargePlatLogisticsService largePlatLogisticsService;

    @Autowired
    private ILargePlatLogisticsBuildingAssetService largePlatLogisticsBuildingAssetService;

    @Autowired
    private ILargePlatLogisticsOfficeAssetService largePlatLogisticsOfficeAssetService;

    @Autowired
    private ILargePlatLogisticsServiceAssetService largePlatLogisticsServiceAssetService;

    @Autowired
    private RestTemplate restTemplate;

    public JSONArray callExternalApi(String url) {
        try {
            HttpHeaders headers = new HttpHeaders();
            headers.set("X-Access-Token", AESUtil.encrypt("M2p5yEL67eZct7gtvT"));
            HttpEntity<String> entity = new HttpEntity<>(null, headers);
            ResponseEntity<String> response = restTemplate.exchange(url, HttpMethod.GET, entity, String.class);
            if (StringUtils.isEmpty(response.getBody())){
                return null;
            }
            return JSONUtil.parseObj(response.getBody()).getJSONArray("data");
        } catch (RestClientException e) {
            return null;
        }
    }

    public void myTask(){

        /*房产土地表*/
        try {
            JSONArray array = callExternalApi(ApiUrlConfig.getLogisticsHousingUrl());
            if (array == null){
                return;
            }
            List<LargeHousingLand> list = array.toList(LargeHousingLand.class);
            if (list.size() < 1){
                return;
            }
            largePlatHousingLandService.remove(new LambdaQueryWrapper<>());
            largePlatHousingLandService.saveBatch(list);
        } catch (Exception e) {

        }

        /*后勤运行监控中心表*/
        largePlatLogisticsService.saveOrUpdate(callExternalApi(ApiUrlConfig.getLogisticsUrl()));

        /*楼宇设备表*/
        try {
            JSONArray array = callExternalApi(ApiUrlConfig.getLogisticsBuildingAssetUrl());
            if (array == null){
                return;
            }
            List<LargeBuildingAssetDirs> list = array.toList(LargeBuildingAssetDirs.class);
            if (list.size() < 1){
                return;
            }
            largePlatLogisticsBuildingAssetService.remove(new LambdaQueryWrapper<>());
            largePlatLogisticsBuildingAssetService.saveBatch(list);
        } catch (Exception e) {

        }

        /*办公资产表*/
        try {
            JSONArray array = callExternalApi(ApiUrlConfig.getLogisticsOfficeAssetUrl());
            if (array == null){
                return;
            }
            List<LargeOfficeAssetDirs> list = array.toList(LargeOfficeAssetDirs.class);
            if (list.size() < 1){
                return;
            }
            largePlatLogisticsOfficeAssetService.remove(new LambdaQueryWrapper<>());
            largePlatLogisticsOfficeAssetService.saveBatch(list);
        } catch (Exception e) {

        }

        /*服务设备表*/
        try {
            JSONArray array = callExternalApi(ApiUrlConfig.getLogisticsServiceAssetUrl());
            if (array == null){
                return;
            }
            List<LargeServiceAssetDirs> list = array.toList(LargeServiceAssetDirs.class);
            if (list.size() < 1){
                return;
            }
            largePlatLogisticsServiceAssetService.remove(new LambdaQueryWrapper<>());
            largePlatLogisticsServiceAssetService.saveBatch(list);
        } catch (Exception e) {

        }


        System.out.println("后勤资源同步完成");
    }
}
