package com.sckj.project.task;

import cn.hutool.json.JSONArray;
import cn.hutool.json.JSONUtil;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.sckj.project.config.ApiUrlConfig;
import com.sckj.project.domain.service.*;
import com.sckj.project.service.service.*;
import com.sckj.project.util.AESUtil;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpMethod;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestClientException;
import org.springframework.web.client.RestTemplate;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
public class ServiceTaskService {

    @Autowired
    private ILargePlatAccessService largePlatAccessService;

    @Autowired
    private ILargePlatBasicsService largePlatBasicsService;

    @Autowired
    private ILargePlatBasicsCompanyService largePlatBasicsCompanyService;

    @Autowired
    private ILargePlatBasicsServerService largePlatBasicsServerService;

    @Autowired
    private ILargePlatBasicsSystemService largePlatBasicsSystemService;

    @Autowired
    private ILargePlatEmployeeHealthService largePlatEmployeeHealthService;

    @Autowired
    private ILargePlatEmployeeHealthIllnessService largePlatEmployeeHealthIllnessService;

    @Autowired
    private ILargePlatEmployeeTypeService largePlatEmployeeTypeService;

    @Autowired
    private ILargePlatEmployeeTypeFlowService largePlatEmployeeTypeFlowService;

    @Autowired
    private ILargePlatGreenFoodsService largePlatGreenFoodsService;

    @Autowired
    private ILargePlatGreenSmartService largePlatGreenSmartService;

    @Autowired
    private ILargePlatGreenSmartOtherService largePlatGreenSmartOtherService;

    @Autowired
    private ILargePlatGreenSmartRankService largePlatGreenSmartRankService;

    @Autowired
    private ILargePlatGreenSmartSafetyService largePlatGreenSmartSafetyService;

    @Autowired
    private ILargePlatPostStationService largePlatPostStationService;

    @Autowired
    private ILargePlatPostStationChartService largePlatPostStationChartService;

    @Autowired
    private ILargePlatPropertyService largePlatPropertyService;

    @Autowired
    private ILargePlatPropertyListService largePlatPropertyListService;

    @Autowired
    private ILargePlatPropertyToolsService largePlatPropertyToolsService;

    @Autowired
    private RestTemplate restTemplate;


    public JSONArray callExternalApi(String url) {
        try {
            HttpHeaders headers = new HttpHeaders();
            headers.set("X-Access-Token", AESUtil.encrypt("M2p5yEL67eZct7gtvT"));
            HttpEntity<String> entity = new HttpEntity<>(null, headers);
            ResponseEntity<String> response = restTemplate.exchange(url, HttpMethod.GET, entity, String.class);
            if (StringUtils.isEmpty(response.getBody())){
                return null;
            }
            return JSONUtil.parseObj(response.getBody()).getJSONArray("data");
        } catch (RestClientException e) {
            return null;
        }
    }

    public void myTask(){

        /*便捷出入*/
        largePlatAccessService.saveOrUpdate(callExternalApi(ApiUrlConfig.getAccessUrl()));

        /*基础运行数据*/
        largePlatBasicsService.saveOrUpdate(callExternalApi(ApiUrlConfig.getBasicsApiUrl()));

        /*公司活跃人数*/
        largePlatBasicsCompanyService.saveOrUpdate(callExternalApi(ApiUrlConfig.getBasicsCompanyUrl()));

        /*服务信息*/
        largePlatBasicsServerService.saveOrUpdate(callExternalApi(ApiUrlConfig.getBasicsServerUrl()));

        /*系统运行峰值情况分析*/
        try {
            JSONArray array = callExternalApi(ApiUrlConfig.getBasicsSystemUrl());
            if (array == null){
                return;
            }
            List<PlatBasicsSystem> list = array.toList(PlatBasicsSystem.class);
            if (list.size() < 1){
                return;
            }
            largePlatBasicsSystemService.remove(new LambdaQueryWrapper<>());
            largePlatBasicsSystemService.saveBatch(list);
        } catch (Exception e) {

        }

        /*员工健康*/
        largePlatEmployeeHealthService.saveOrUpdate(callExternalApi(ApiUrlConfig.getHealthUrl()));

        /*多发疾病排行*/
        try {
            JSONArray array = callExternalApi(ApiUrlConfig.getHealthIllnessUrl());
            if (array == null){
                return;
            }
            List<PlatEmployeeHealthIllness> list = array.toList(PlatEmployeeHealthIllness.class);
            if (list.size() < 1){
                return;
            }
            largePlatEmployeeHealthIllnessService.remove(new LambdaQueryWrapper<>());
            largePlatEmployeeHealthIllnessService.saveBatch(list);
        } catch (Exception e) {

        }

        /*员工概况*/
        largePlatEmployeeTypeService.saveOrUpdate(callExternalApi(ApiUrlConfig.getEmployeeTypeUrl()));

        /*近一周人流量统计*/
        try {
            JSONArray array = callExternalApi(ApiUrlConfig.getEmployeeTypeFlowUrl());
            if (array == null){
                return;
            }
            List<PlatEmployeeTypeFlow> list = array.toList(PlatEmployeeTypeFlow.class);
            if (list.size() < 1){
                return;
            }
            largePlatEmployeeTypeFlowService.remove(new LambdaQueryWrapper<>());
            largePlatEmployeeTypeFlowService.saveBatch(list);
        } catch (Exception e) {

        }

        /*菜谱数据*/
        largePlatGreenFoodsService.saveOrUpdate(callExternalApi(ApiUrlConfig.getGreenFoodsUrl()));

        /*绿智食堂*/
        largePlatGreenSmartService.saveOrUpdate(callExternalApi(ApiUrlConfig.getGreenSmartUrl()));

        /*绿智食堂 其他参数*/
        largePlatGreenSmartOtherService.saveOrUpdate(callExternalApi(ApiUrlConfig.getGreenSmartOtherUrl()));

        /*绿智食堂 排名*/
        try {
            JSONArray array = callExternalApi(ApiUrlConfig.getGreenSmartRankUrl());
            if (array == null){
                return;
            }
            List<PlatGreenSmartRank> list = array.toList(PlatGreenSmartRank.class);
            if (list.size() < 1){
                return;
            }
            largePlatGreenSmartRankService.remove(new LambdaQueryWrapper<>());
            largePlatGreenSmartRankService.saveBatch(list);
        } catch (Exception e) {

        }

        /*食堂安全管理*/
        largePlatGreenSmartSafetyService.saveOrUpdate(callExternalApi(ApiUrlConfig.getGreenSmartSafetyUrl()));

        /*物业服务*/
        largePlatPostStationService.saveOrUpdate(callExternalApi(ApiUrlConfig.getPostStationUrl()));

        /*近六个月报修分类占比*/
        try {
            JSONArray array = callExternalApi(ApiUrlConfig.getPostStationChartUrl());
            if (array == null){
                return;
            }
            List<PlatPostStationChart> list = array.toList(PlatPostStationChart.class);
            if (list.size() < 1){
                return;
            }
            largePlatPostStationChartService.remove(new LambdaQueryWrapper<>());
            largePlatPostStationChartService.saveBatch(list);
        } catch (Exception e) {

        }

        /*共享驿站*/
        largePlatPropertyService.saveOrUpdate(callExternalApi(ApiUrlConfig.getPropertyUrl()));

        /*驿站列表*/
        largePlatPropertyListService.saveOrUpdate(callExternalApi(ApiUrlConfig.getPropertyListUrl()));

        /*工具表列表*/
        largePlatPropertyToolsService.saveOrUpdate(callExternalApi(ApiUrlConfig.getPropertyToolsUrl()));

        System.out.println("服务保障同步完成");
    }
}
